Magellan Linux

Diff of /trunk/installer-simple/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2323 by niro, Fri Jan 3 13:19:11 2014 UTC revision 2427 by niro, Tue Jan 7 14:09:01 2014 UTC
# Line 7  Line 7 
7  # Niels Rogalla <niro@magellan-linux.de>  # Niels Rogalla <niro@magellan-linux.de>
8  #  #
9    
10  #images: (get ${CDIMAGENAME})  # ignore the environment
11  source /mnt/cdrom/system/images.conf  LC_ALL=C
12    # include dir
13    INSTALLER_LIBDIR="%LIBDIR%"
14    
15  #Includes  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
16  source /usr/lib/installer/functions/findhdd.sh > /dev/null  # -> now in images.conf
17  ### bugfix ###############################  CURRENTLINE=0
 cdromdev="$(echo ${cdromdev} | sed 's/ //')"  
 ########################################  
18    
19  ### System/Config Version  die()
20  VERSION="%VERSIONTAG%"  {
21  TITLE="Installer - ${VERSION}"   echo "Error: $@"
22     exit 1
23    }
24    
25  CDPATH="/mnt/cdrom"  # load common includes
26  INSTALLPATH="/mnt/magellan"  for inc in %SYSCONFDIR%/installer.conf \
27     ${INSTALLER_LIBDIR}/functions/common.sh \
28     ${INSTALLER_LIBDIR}/functions/common-dialogs.sh \
29     ${INSTALLER_LIBDIR}/functions/hwdetection.sh \
30     ${INSTALLER_LIBDIR}/functions/installer-dialogs.sh
31    do
32     if [ -e ${inc} ]
33     then
34     source "${inc}"
35     else
36     die "'${inc}' not found"
37     fi
38    done
39    
40  ### WICHTIG: anzahl lines in der autosta_lx.tar.gz -1  # TOTALLINES=linecount of ${CDIMAGENAME}-tarball -1 !
41    # -> now in images.conf
42    CDIMAGENAME=""
43    TOTALLINES=""
44  CURRENTLINE=0  CURRENTLINE=0
45  #TOTALLINES=11072 # -> now in images.conf  if [ -e /mnt/cdrom/system/images.conf ]
46    then
47     source /mnt/cdrom/system/images.conf
48     # check if all required variables are set
49     [[ -z ${CDIMAGENAME} ]] && die "CDIMAGENAME is empty in /mnt/cdrom/system/images.conf"
50     [[ -z ${TOTALLINES} ]] && die "TOTALLINES is empty in /mnt/cdrom/system/images.conf"
51    else
52     die "/mnt/cdrom/system/images.conf not found"
53    fi
54    
55  # standard kernel opts  ### System/Config Version
56  KERNELOPTS="quiet video=1024x768"  VERSION="%VERSIONTAG%"
57    TITLE="${DEFAULT_TITLE} - ${VERSION}"
58    
59  # grub options  # some sane defaults
60    CDROOT="${DEFAULT_CDROOT}"
61    INSTALLROOT="${DEFAULT_INSTALLROOT}"
62    KERNELPKG="${DEFAULT_KERNELPKG}"
63    KERNELOPTS="${DEFAULT_KERNELOPTS}"
64  GRUBLEGACYOPTS=""  GRUBLEGACYOPTS=""
65  GRUB2OPTS=""  GRUB2OPTS=""
   
 # fdisk options  
66  FDISKPARTIONBELOW256MB=0  FDISKPARTIONBELOW256MB=0
   
 # default specialdevices  
67  SPECIALDEVICE=""  SPECIALDEVICE=""
68  FORMFACTOR="desktop"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
69    FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
 # target filesystem  
 FORMAT_FILESYSTEM="ext4"  
70    
71  #################################################  #################################################
72  #  DIALOG BOXEN #  #  DIALOG BOXEN #
73  #################################################  #################################################
74    
75  die()  trap_exit()
76  {  {
77   ERROR=$1   is_mounted --location "${INSTALLROOT}/dev" && umount ${INSTALLROOT}/dev
78   RETVAL=$?   is_mounted --location "${INSTALLROOT}/proc" && umount ${INSTALLROOT}/proc
79     is_mounted --location "${INSTALLROOT}/sys" && umount ${INSTALLROOT}/sys
80     is_mounted --location "${INSTALLROOT}/boot" && umount ${INSTALLROOT}/boot
81     is_mounted --location "${INSTALLROOT}" && umount ${INSTALLROOT}
82    
83     echo $"Installation aborted."
84     exit 1
85    }
86    
87    dialog_die()
88    {
89     ERROR="$1"
90     RETVAL="$?"
91   dialog_install_failure   dialog_install_failure
92   exit 1   exit 1
93  }  }
94    
95  dialog_warning()  dialog_warning()
96  {  {
97   dialog \   local retval
98   --backtitle "${TITLE}" \  
99   --colors \   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
100   --defaultno \   retval=$?
101   --yesno "\Z1 !!! Achtung !!! \Zn\n\n\   if [[ ${retval} -eq 1 ]]
  Diese Festplatte wird unwiederruflich geloescht werden.\n\n\  
  Soll ich wirklich fortfahren ?" 10 70  
  RES=$?  
  if [[ ${RES} -eq 1 ]]  
102   then   then
103   clear   clear
104   echo "Der Vorgang wurde abgebrochen."   echo $"The process was aborted."
105   exit 1   exit 1
106   fi   fi
107  }  }
108    
109  dialog_setup_hdd_info()  dialog_setup_hdd_info()
110  {  {
111   local SHDD="$(echo ${HDD} | sed 's/\/dev\///')"   local SHDD="${HDD//\/dev\/}"
112    
113   dialog \   messagebox -h $"[ Harddrive partitioning ]" \
114   --colors \   $"\nPlease create 1 partition.\n\n\[ \Z3${SHDD}1\Zn ] type: \Z3linux\Zn with the whole diskspace\n\Please mark ${SHDD}1 \Z3bootable\Zn."
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 3 Partitionen an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit ca. 50MB\n\  
  [ \Z3${SHDD}2\Zn ] Typ: \Z3Linux Swap\Zn mit ca. 256MB\n\  
  [ \Z3${SHDD}3\Zn ] Typ: \Z3Linux \Zn mit dem Rest (min. 256MB)\n\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
 }  
   
 dialog_setup_hdd_info_flash()  
 {  
  local SHDD="$(echo $HDD | sed 's/\/dev\///')"  
   
  dialog \  
  --colors \  
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nBitte legen Sie 1 Partition an.\n\n\  
  [ \Z3${SHDD}1\Zn ] Typ: \Z3Linux\Zn mit dem gesamten Speicher\n\  
  Bitte ${SHDD}1 als \Z3bootable\Zn markieren." 12 81  
115  }  }
116    
117  dialog_setup_hdd_info_auto()  dialog_setup_hdd_info_auto()
118  {  {
119   local SHDD="$(echo $HDD | sed 's/\/dev\///')"   local SHDD="${HDD//\/dev\/}"
120    
121   dialog \   messagebox -h $"[ Harddrive partitioning ]" \
122   --colors \   $"\Z1Warning!\Zn\n\nAll data on disk [ \Z3${HDD}\Zn ] will be erased!"
  --title "[ Festplatten Partitionierung ]" \  
  --backtitle "${TITLE}" \  
  --ok-label "Weiter" \  
  --msgbox "\nAchtung!\n\  
  Alle Daten werden von der Disk [ \Z3${HDD}\Zn ] gelöscht!" 12 81  
123  }  }
124    
125  dialog_setup_system_menu()  dialog_setup_system_menu()
126  {  {
127   local i   local mode
128     local retval
129    
130   i=$(dialog \   mode=$(menubox -h $"[ Harddrive partitioning ]" $"\nSelect an installation mode" \
131   --backtitle "${TITLE}" \   $"1:Automatic setup (recommended)" \
132   --title "[ Festplatten Partitionierung ]" \   ":" \
133   --cancel-label "Abbrechen" \   $":\Z1Expert modes:\Zn" \
134   --ok-label "Weiter" \   $"2:Common IDE-disk (manual setup)")
135   --stdout \   retval=$?
136   --colors \   [[ ${retval} -eq 1 ]] && return 1
137   --menu "\nWaehlen Sie die Installations-Methode" 14 70 5 \   if [[ ${retval} -eq 0 ]]
  "1" "Automatisches Setup (Empfohlen)" \  
  "" "" \  
  "" "\Z1Experten Modi:\Zn" \  
  "2" "Normale IDE-Disk (Manuell)" \  
  "3" "Flash-Speicher (Manuell)")  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
138   then   then
139   case "${i}" in   case "${mode}" in
140   "1") run_install_auto ;;   "1") run_install_auto ;;
141           "2") run_install_normal ;;   "2") run_install_normal ;;
  "3") run_install_flash ;;  
142   "") dialog_setup_system_menu;;   "") dialog_setup_system_menu;;
143   esac   esac
144   fi   fi
# Line 149  dialog_setup_system_menu() Line 146  dialog_setup_system_menu()
146    
147  dialog_hardware_detection()  dialog_hardware_detection()
148  {  {
149   local i   local message
  local hwtmp  
   
  if [ -x $(which mktemp &> /dev/null) ]  
  then  
  hwtmp="$(mktemp)"  
  else  
  hwtmp="/tmp/hwtmp.sh"  
  fi  
150    
151   [[ ! -z ${installdevs} ]] && installdevs=""   run_hardware_detection_disks
152    
153   echo "dialog \\"  > ${hwtmp}   message+=$"Harddrives:\n"
  echo "--backtitle \"${TITLE}\" \\" >> ${hwtmp}  
  echo "--ok-label \"Weiter\" \\" >> ${hwtmp}  
  echo "--stdout \\" >> ${hwtmp}  
  echo "--colors \\" >> ${hwtmp}  
  echo "--msgbox \"Gefundene Hardware:\n\n \\" >> ${hwtmp}  
  echo " Festplatten:\n \\" >> ${hwtmp}  
154    
155   if [[ ! -z ${scsidisks} ]]   if [[ ! -z ${ALL_DISKS} ]]
156   then   then
157   for i in ${scsidisks}   for i in ${ALL_DISKS}
158   do   do
159   if [[ ${i} != ${cdromdev} ]]   message+="\Z3${i}\Zn "
  then  
  echo " \\Z7SCSI: \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
160   done   done
161     message+="\n"
162   fi   fi
163    
164   if [[ ! -z ${idedisks} ]]   if [[ ! -z ${ALL_CDROMS} ]]
165   then   then
166   for i in ${idedisks}   message+="\n"
167     message+=$"Optical disk drives:\n"
168     for i in ${ALL_CDROMS}
169   do   do
170   if [[ ${i} != ${cdromdev} ]]   message+="\Z3${i}\Zn"
  then  
  echo " \\Z7IDE:  \\Z3${i}\\Zn\n \\" >> ${hwtmp}  
  installdevs="${installdevs} ${i}"  
  fi  
171   done   done
172   fi   message+="\n"
   
  if [[ ! -z ${cdromdev} ]]  
  then  
  echo " \n \\" >> ${hwtmp}  
  echo " \\Z7andere Laufwerke:\n \\" >> ${hwtmp}  
  echo " CDROM: \\Z3${cdromdev}\\Zn\n \\" >> ${hwtmp}  
173   fi   fi
174    
175   # other devices   # other devices
176   run_hardware_detection   run_hardware_detection
177   case "${SPECIALDEVICE}" in   case "${SPECIALDEVICE}" in
178   zotac*) echo " \n\n\n \\Z2Zotac Device erkannt.\\Zn \\" >> ${hwtmp} ;;   zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
179   rangee) echo " \n\n\n \\Z2Rangee Device erkannt.\\Zn \\" >> ${hwtmp} ;;   rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
180   maxdata) echo " \n\n\n \\Z2Maxdata Device erkannt.\\Zn \\" >> ${hwtmp} ;;   maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
181   *) echo " \n\n\n \\ZnStandard Device erkannt.\\Zn \\" >> ${hwtmp} ;;   *) message+=$"\n \\ZnCommon device detected.\Zn" ;;
182   esac   esac
183   if [[ ${FORMFACTOR} = laptop ]]   if [[ ${FORMFACTOR} = laptop ]]
184   then   then
185   echo " \n \\ZnFormfactor Laptop, Powersave Modus 'ondemand' wird aktiviert.\\Zn \\" >> ${hwtmp}   message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving  mode.\Zn"
186   fi   fi
187    
188   echo " \" 14 70" >> ${hwtmp}   messagebox -y 15 -h $"Detected hardware:" "${message}"
  chmod a+x ${hwtmp}  
  ${hwtmp}  
   
  # remove tmp file  
  if [[ -f ${hwtmp} ]]  
  then  
  rm ${hwtmp}  
  fi  
189  }  }
190    
191  dialog_setup_hdd_partitions_manuell()  dialog_setup_hdd_partitions_manual()
192  {  {
193   local i   local i
194     local retval
195    
196   if [[ -z ${installdevs} ]]   if [[ -z ${ALL_DISKS} ]]
197   then   then
198   dialog \   dialog_no_harddrive_found
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
199   exit 1   exit 1
200   else   else
201     HDD=$(dialog_select_target_harddrive)
202   echo "dialog \\" > /tmp/hddtmp.sh   retval=$?
203   echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh   [[ ${retval} -eq 1 ]] && return 1
204   echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh   if [[ ${retval} -eq 0 ]]
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
205   then   then
206   dialog_setup_hdd_info   dialog_setup_hdd_info
207   setup_hdd_partitions_manuell   setup_hdd_partitions_manual
  fi  
  fi  
 }  
   
 dialog_setup_hdd_partitions_manuell_flash()  
 {  
  local i  
   
  if [[ -z ${installdevs} ]]  
  then  
  dialog \  
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
  exit 1  
  else  
   
  echo "dialog \\" > /tmp/hddtmp.sh  
  echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh  
  echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh  
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_flash  
  setup_hdd_partitions_manuell_flash  
208   fi   fi
209   fi   fi
210  }  }
# Line 303  dialog_setup_hdd_partitions_manuell_flas Line 212  dialog_setup_hdd_partitions_manuell_flas
212  dialog_setup_hdd_partitions_auto()  dialog_setup_hdd_partitions_auto()
213  {  {
214   local i   local i
215     local retval
216    
217   if [[ -z ${installdevs} ]]   if [[ -z ${ALL_DISKS} ]]
218   then   then
219   dialog \   dialog_no_harddrive_found
  --backtitle "${TITLE}" \  
  --ok-label "Beenden" \  
  --msgbox "Kein geeignetes Laufwerk gefunden.\nDie Installation ist fehlgeschlagen." 6 70  
220   exit 1   exit 1
221   else   else
222     HDD=$(dialog_select_target_harddrive)
223   echo "dialog \\" > /tmp/hddtmp.sh   retval=$?
224   echo "--backtitle \"${TITLE}\" \\" >> /tmp/hddtmp.sh   [[ ${retval} -eq 1 ]] && return 1
225   echo "--ok-label \"Weiter\" \\" >> /tmp/hddtmp.sh   if [[ ${retval} -eq 0 ]]
  echo "--cancel-label \"Beenden\" \\" >> /tmp/hddtmp.sh  
  echo "--stdout \\" >> /tmp/hddtmp.sh  
  echo "--menu \"Installations Laufwerk auswaehlen:\" 10 70 3 \\" >> /tmp/hddtmp.sh  
   
  for i in ${installdevs}  
  do  
  echo "\"${i}\" \"\" \\" >> /tmp/hddtmp.sh  
  done  
  echo -e "\n" >> /tmp/hddtmp.sh  
   
  chmod a+x /tmp/hddtmp.sh  
  HDD="$(/tmp/hddtmp.sh)"  
  RES=$?  
  [[ ${RES} -eq 1 ]] && return 1  
  if [[ ${RES} -eq 0 ]]  
226   then   then
227   dialog_setup_hdd_info_auto   dialog_setup_hdd_info_auto
228   dialog_setup_hdd_create_partitions   dialog_setup_hdd_create_partitions
# Line 339  dialog_setup_hdd_partitions_auto() Line 231  dialog_setup_hdd_partitions_auto()
231   fi   fi
232  }  }
233    
234  dialog_setup_hdd_create_partitions()  run_hardware_detection_disks()
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Erstelle Disk Partitionen ..." 3 70  
 }  
   
 dialog_setup_hdd_format()  
235  {  {
236   dialog \   local bootdev
  --backtitle "${TITLE}" \  
  --infobox "Erstelle Datei-Systeme ..." 3 70  
 }  
   
 dialog_install_settings()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Speichere System-Einstellungen ..." 3 70  
 }  
237    
238  dialog_install_system_image()   # all disks but exclude ramdisks
239  {   export ALL_DISKS=$(get_hwinfo disk | sed '/\/dev\/ram[0-9].*/d')
240   dialog \   # remove the boot device from ALL_DISKS if it was an usbstick
241   --backtitle "${TITLE}" \   if [[ $(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f3) != iso9660 ]]
242   --gauge "Kopiere System-Image ..." 6 80   then
243     bootdev="$(grep '[[:space:]]/mnt/cdrom[[:space:]]' /proc/mounts | cut -d' ' -f1 | sed 's:[0-9]::g')"
244     export ALL_DISKS=$(echo "${ALL_DISKS}" | grep -v "${bootdev}")
245     fi
246     export ALL_CDROMS="$(get_hwinfo cdrom)"
247  }  }
248    
249  dialog_install_meter()  install_meter()
250  {  {
251   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
252   do   do
# Line 380  dialog_install_meter() Line 259  dialog_install_meter()
259   return 0   return 0
260  }  }
261    
   
 dialog_install_bootsector()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --infobox "Schreibe den Bootsektor ..." 3 70  
 }  
   
 dialog_install_successful()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --colors \  
  --msgbox "Die Installation war \Z2erfolgreich\Zn." 5 81  
 }  
   
 dialog_install_failure()  
 {  
  dialog \  
  --backtitle "${TITLE}" \  
  --colors \  
  --msgbox "Die Installation ist \Z1Fehlgeschlagen\Zn.\n\n\  
  Fehler bei ${ERROR}, RetVal: ${RETVAL} \  
  " 10 81  
 }  
   
262  dialog_main()  dialog_main()
263  {  {
264   METHOD=0   local method=0
265     local retval
266    
267   while [[ ${METHOD} -le 2 ]]   while [[ ${method} -le 2 ]]
268   do   do
269   METHOD=$(dialog \   method=$(menubox $"Configuration:" \
270   --backtitle "${TITLE}" \   $"1:Install system" \
271   --no-cancel \   $"2:Show detected harddrives" \
272   --ok-label "Weiter" \   $"3:Exit and reboot" \
273   --stdout \   $"4:Exit and drop into a shell")
274   --menu "Konfiguration" 14 70 5 \   retval=$?
275   "1" "AutoSta_LX installieren" \   [[ ${retval} -eq 1 ]] && exit 1
276   "2" "Uebersicht gefundener Laufwerke" \   if [[ ${retval} -eq 0 ]]
  "3" "Beenden und neustarten" \  
  "4" "Beenden und eine Shell starten")  
  RES=$?  
  [[ ${RES} -eq 1 ]] && exit 1  
  if [[ ${RES} -eq 0 ]]  
277   then   then
278   case ${METHOD} in   case ${method} in
279           "1") dialog_setup_system_menu ;;   "1") dialog_setup_system_menu ;;
280   "2") dialog_hardware_detection ;;   "2") dialog_hardware_detection ;;
281   "3") install_do_reboot ;;   "3") install_do_reboot ;;
282   "4") /bin/bash --login -i ;;   "4") /bin/bash --login -i ;;
# Line 501  hdd_size_below_256mb() Line 350  hdd_size_below_256mb()
350   local hdd="$1"   local hdd="$1"
351   local size   local size
352   local retval   local retval
353   [[ -z ${hdd} ]] && die "Error: get_hdd_size() no \$hdd given!"   [[ -z ${hdd} ]] && dialog_die "Error: get_hdd_size() no \$hdd given!"
354    
355   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')
356   if [[ ${size} -le 257000000 ]]   if [[ ${size} -le 257000000 ]]
# Line 530  setup_hdd_partitions_auto() Line 379  setup_hdd_partitions_auto()
379   fi   fi
380    
381   ## delete disk   ## delete disk
382   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || die   dd if=/dev/zero of=${HDD} count=1 &> /dev/null || dialog_die
383    
384   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]   if [[ ${FDISKPARTIONBELOW256MB} = 1 ]]
385   then   then
# Line 576  EOF Line 425  EOF
425   fi   fi
426  }  }
427    
428  setup_hdd_partitions_manuell()  setup_hdd_partitions_manual()
 {  
  BOOTHDD="${HDD}1"  
  SWAPHDD="${HDD}2"  
  ROOTHDD="${HDD}3"  
   
  ## hdds partitionieren manuell  
  cfdisk ${HDD} || die  
 }  
   
 setup_hdd_partitions_manuell_flash()  
429  {  {
430   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
431    
432   ## hdds partitionieren manuell   ## hdds partitionieren manual
433   cfdisk ${HDD} || die   cfdisk ${HDD} || dialog_die
434  }  }
435    
436  setup_hdd_format()  setup_hdd_format()
437  {  {
438   mkswap ${SWAPHDD} || die   mke2fs -j -q ${ROOTHDD} || dialog_die
  mke2fs -j -q ${BOOTHDD} || die  
  mke2fs -j -q ${ROOTHDD} || die  
 }  
   
 setup_hdd_format_flash()  
 {  
  mke2fs -j -q ${ROOTHDD} || die  
439  }  }
440    
441  install_mount_rootfs()  install_mount_rootfs()
442  {  {
443   swapon ${SWAPHDD} || die   mount ${ROOTHDD} ${INSTALLROOT} || dialog_die
444   mount ${ROOTHDD} ${INSTALLPATH} || die   install -d ${INSTALLROOT}/boot || dialog_die
445   install -d ${INSTALLPATH}/boot || die   cd ${INSTALLROOT} || dialog_die
  mount ${BOOTHDD} ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
 }  
   
 install_mount_rootfs_flash()  
 {  
  mount ${ROOTHDD} ${INSTALLPATH} || die  
  install -d ${INSTALLPATH}/boot || die  
  cd ${INSTALLPATH} || die  
446  }  }
447    
448  install_system_image()  install_system_image()
449  {  {
450   tar xvjpf ${CDPATH}/system/${CDIMAGENAME} -C ${INSTALLPATH}   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}
451  }  }
452    
453  install_bootsector_chroot()  install_bootsector_chroot()
454  {  {
455   local my_roothdd   local my_roothdd
456   local grubconf=${INSTALLPATH}/boot/grub/grub.conf   local grubconf=${INSTALLROOT}/boot/grub/grub.conf
457   local grub2conf=/boot/grub/grub.cfg   local grub2conf=/boot/grub/grub.cfg
458    
459   # check for grub2   # check for grub2
460   if [[ -f ${INSTALLPATH}/sbin/grub-mkconfig ]]   if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]
461   then   then
462   # needed by grub-mkconfig on the first run   # needed by grub-mkconfig on the first run
463   if [[ ! -f ${INSTALLPATH}/boot/grub/video.lst ]]   if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]
464   then   then
465   install -m0644 ${INSTALLPATH}/lib/grub/*/video.lst ${INSTALLPATH}/boot/grub/video.lst || die   install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die
466   fi   fi
467    
468   # set kernelopts   # set kernelopts
469   if [[ -f ${INSTALLPATH}/etc/conf.d/grub ]]   if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]
470   then   then
471   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLPATH}/etc/conf.d/grub || die   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die
472   else   else
473   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLPATH}/etc/conf.d/grub || die   echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLROOT}/etc/conf.d/grub || dialog_die
474   fi   fi
475   echo 'grub-mkdevicemap' > ${INSTALLPATH}/root/.installrc || die   echo 'grub-mkdevicemap' > ${INSTALLROOT}/root/.installrc || dialog_die
476   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die   echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
477   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLPATH}/root/.installrc || die   echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die
478   echo "exit 0" >> ${INSTALLPATH}/root/.installrc || die   echo "exit 0" >> ${INSTALLROOT}/root/.installrc || dialog_die
479    
480   # grub-legacy   # grub-legacy
481   else   else
482   ### grubconf schreiben   ### grubconf schreiben
483   source ${INSTALLPATH}/boot/kernelversion   source ${INSTALLROOT}/boot/kernelversion
484    
485   #for alx only   #for alx only
486   if [ -e ${INSTALLPATH}/etc/alx_version ]   if [ -e ${INSTALLROOT}/etc/alx_version ]
487   then   then
488   OLD_ALXVER="${ALXVER}"   OLD_ALXVER="${ALXVER}"
489   source ${INSTALLPATH}/etc/alx_version   source ${INSTALLROOT}/etc/alx_version
490   KRNVER="ALX-${ALXVER}"   KRNVER="ALX-${ALXVER}"
491   ALXVER="${OLD_ALXVER}"   ALXVER="${OLD_ALXVER}"
492   fi   fi
# Line 680  install_bootsector_chroot() Line 503  install_bootsector_chroot()
503   my_roothdd="${ROOTHDD}"   my_roothdd="${ROOTHDD}"
504   fi   fi
505    
506   : > ${grubconf} || die   : > ${grubconf} || dialog_die
507   echo "default 0" >> ${grubconf} || die   echo "default 0" >> ${grubconf} || dialog_die
508   echo "timeout 3" >> ${grubconf} || die   echo "timeout 3" >> ${grubconf} || dialog_die
509   # using current root password   # using current root password
510   echo "password --md5 $(cat ${INSTALLPATH}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || die   echo "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || dialog_die
511    
512   echo  >> ${grubconf} || die   echo  >> ${grubconf} || dialog_die
513   echo "# normal boot" >> ${grubconf} || die   echo "# normal boot" >> ${grubconf} || dialog_die
514   echo "title ${KRNVER}" >> ${grubconf} || die   echo "title ${KRNVER}" >> ${grubconf} || dialog_die
515   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
516   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || dialog_die
517   if is_initrd_supported   if is_initrd_supported
518   then   then
519   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
520   fi   fi
521    
522   echo >> ${grubconf} || die   echo >> ${grubconf} || dialog_die
523   echo "# admin boot" >> ${grubconf} || die   echo "# admin boot" >> ${grubconf} || dialog_die
524   echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || die   echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || dialog_die
525   echo "lock"  >> ${grubconf} || die   echo "lock"  >> ${grubconf} || dialog_die
526   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
527   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || dialog_die
528   if is_initrd_supported   if is_initrd_supported
529   then   then
530   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
531   fi   fi
532    
533   echo >> ${grubconf} || die   echo >> ${grubconf} || dialog_die
534   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || die   echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || dialog_die
535   echo "lock"  >> ${grubconf} || die   echo "lock"  >> ${grubconf} || dialog_die
536   echo "root (hd0,0)" >> ${grubconf} || die   echo "root (hd0,0)" >> ${grubconf} || dialog_die
537   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || die   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || dialog_die
538   if is_initrd_supported   if is_initrd_supported
539   then   then
540   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || die   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die
541   fi   fi
542    
543   # bootsector schreiben chrooted schreiben (lfs/magellan)   # bootsector schreiben chrooted schreiben (lfs/magellan)
544   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
545  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null  /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null
546  root (hd0,0)  root (hd0,0)
547  setup (hd0)  setup (hd0)
# Line 728  exit 0 Line 551  exit 0
551  CHROOTEOF  CHROOTEOF
552   fi   fi
553    
554   ## enters chroot   ## enter chroot
555   mount -t proc proc ${INSTALLPATH}/proc   mount -t proc proc ${INSTALLROOT}/proc
556   mount -t sysfs sysfs ${INSTALLPATH}/sys   mount -t sysfs sysfs ${INSTALLROOT}/sys
557   mount -o bind /dev ${INSTALLPATH}/dev   mount -o bind /dev ${INSTALLROOT}/dev
558   chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
559   umount ${INSTALLPATH}/proc   umount ${INSTALLROOT}/proc
560   umount ${INSTALLPATH}/sys   umount ${INSTALLROOT}/sys
561   umount ${INSTALLPATH}/dev   umount ${INSTALLROOT}/dev
562   rm ${INSTALLPATH}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
563  }  }
564    
565  is_initrd_supported()  is_initrd_supported()
566  {  {
567   # only generate initrds if the cmd exists   # only generate initrds if the cmd exists
568   [[ -x ${INSTALLPATH}/sbin/mkinitrd ]] && return 0   [[ -x ${INSTALLROOT}/sbin/mkinitrd ]] && return 0
569   return 1   return 1
570  }  }
571    
# Line 773  install_initrd_chroot() Line 596  install_initrd_chroot()
596   fi   fi
597    
598   # install an appropriate uvesafb.conf   # install an appropriate uvesafb.conf
599   install -d ${INSTALLPATH}/etc/modprobe.d || die   install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die
600   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLPATH}/etc/modprobe.d/uvesafb.conf || die   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLROOT}/etc/modprobe.d/uvesafb.conf || dialog_die
601    
602   # install an appropriate viafb.conf   # install an appropriate viafb.conf
603   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLPATH}/etc/modprobe.d/viafb.conf || die   echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLROOT}/etc/modprobe.d/viafb.conf || dialog_die
604    
605   # install an appropriate i810fb.conf   # install an appropriate i810fb.conf
606   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLPATH}/etc/modprobe.d/i810fb.conf || die   echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLROOT}/etc/modprobe.d/i810fb.conf || dialog_die
607    
608   cat > ${INSTALLPATH}/root/.installrc << CHROOTEOF   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF
609  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd
610  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null
611  exit 0  exit 0
612  CHROOTEOF  CHROOTEOF
613    
614   ## enters chroot   ## enters chroot
615   mount -t proc proc ${INSTALLPATH}/proc   mount -t proc proc ${INSTALLROOT}/proc
616   mount -t sysfs sysfs ${INSTALLPATH}/sys   mount -t sysfs sysfs ${INSTALLROOT}/sys
617   mount -o bind /dev ${INSTALLPATH}/dev   mount -o bind /dev ${INSTALLROOT}/dev
618   chroot ${INSTALLPATH} /bin/bash --rcfile /root/.installrc -i   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i
619   umount ${INSTALLPATH}/proc   umount ${INSTALLROOT}/proc
620   umount ${INSTALLPATH}/sys   umount ${INSTALLROOT}/sys
621   umount ${INSTALLPATH}/dev   umount ${INSTALLROOT}/dev
622   rm ${INSTALLPATH}/root/.installrc   rm ${INSTALLROOT}/root/.installrc
623  }  }
624    
625  is_uuid_supported()  is_uuid_supported()
626  {  {
627   if [[ -x $(which busybox.mkinitrd &> /dev/null) ]]   if [[ -x $(type -P busybox.mkinitrd) ]]
628   then   then
629   # only detect uuids if supported   # only detect uuids if supported
630   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]   if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]
# Line 820  get_uuid() Line 643  get_uuid()
643   local TYPE   local TYPE
644    
645   local dev="$1"   local dev="$1"
646   [[ -z ${dev} ]] && die "no dev given"   [[ -z ${dev} ]] && dialog_die "no dev given"
647    
648   # check if given device is already an UUID   # check if given device is already an UUID
649   if [[ ${dev/UUID=/}x != ${dev}x ]]   if [[ ${dev/UUID=/}x != ${dev}x ]]
# Line 837  install_system_settings() Line 660  install_system_settings()
660   # schreibe fstab   # schreibe fstab
661   if is_uuid_supported   if is_uuid_supported
662   then   then
663   echo -e "UUID=$(get_uuid ${BOOTHDD})\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
664   else   else
665   echo -e "${BOOTHDD}\t/boot\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1" > ${INSTALLPATH}/etc/fstab || die   echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
666   fi   fi
667   # not needed busybox loads all with swapon -a, even if not mentioned in fstab   # not needed busybox loads all with swapon -a, even if not mentioned in fstab
668   #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLPATH}/etc/fstab || die   #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
669   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die   echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
670   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die   echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die
671    
672   # install network config skeleton   # install network config skeleton
673   install -m0644 ${INSTALLPATH}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLPATH}/etc/conf.d/ || die   install -m0644 ${INSTALLROOT}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLROOT}/etc/conf.d/ || dialog_die
674    
675   # intel framebufer quirk   # intel framebufer quirk
676   if [[ -e /proc/fb ]]   if [[ -e /proc/fb ]]
# Line 859  install_system_settings() Line 680  install_system_settings()
680   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
681   if [[ ${fbdev} != 0 ]]   if [[ ${fbdev} != 0 ]]
682   then   then
683   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLPATH}/etc/splash/splash.conf || die   sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die
684   fi   fi
685   fi   fi
686   fi   fi
687  }  }
688    
 install_system_settings_flash()  
 {  
  # schreibe fstab  
  if is_uuid_supported  
  then  
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die  
  else  
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" > ${INSTALLPATH}/etc/fstab || die  
  fi  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLPATH}/etc/fstab || die  
 }  
   
689  install_umount_rootfs()  install_umount_rootfs()
690  {  {
691   cd /   cd /
692   umount ${INSTALLPATH}/boot || die   umount ${INSTALLROOT}/boot || dialog_die
693   umount ${INSTALLPATH} || die   umount ${INSTALLROOT} || dialog_die
  swapoff ${SWAPHDD} || die  
 }  
   
 install_umount_rootfs_flash()  
 {  
  cd /  
  umount ${INSTALLPATH} || die  
694  }  }
695    
696  install_do_reboot()  install_do_reboot()
# Line 905  run_install_normal() Line 706  run_install_normal()
706  {  {
707   dialog_hardware_detection   dialog_hardware_detection
708    
709   dialog_setup_hdd_partitions_manuell   dialog_setup_hdd_partitions_manual
710   dialog_setup_hdd_format   dialog_setup_hdd_format
711   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
712   install_mount_rootfs   install_mount_rootfs
713   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
714    
715   dialog_install_settings   dialog_install_settings
716   sleep 1   sleep 1
717   install_system_settings   install_system_settings
718     dialog_install_initrd
719   install_initrd_chroot   install_initrd_chroot
720    
721   dialog_install_bootsector   dialog_install_bootsector
# Line 923  run_install_normal() Line 725  run_install_normal()
725   dialog_install_successful   dialog_install_successful
726  }  }
727    
 run_install_flash()  
 {  
  dialog_hardware_detection  
   
  dialog_setup_hdd_partitions_manuell_flash  
  dialog_setup_hdd_format  
  setup_hdd_format_flash > /dev/null  
  install_mount_rootfs_flash  
  (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image  
   
  dialog_install_settings  
  sleep 1  
  install_system_settings_flash  
  install_initrd_chroot  
   
  dialog_install_bootsector  
  install_bootsector_chroot  
   
  install_umount_rootfs_flash  
  dialog_install_successful  
 }  
   
728  run_install_auto()  run_install_auto()
729  {  {
730   dialog_hardware_detection   dialog_hardware_detection
731    
732   dialog_setup_hdd_partitions_auto   dialog_setup_hdd_partitions_auto
733   dialog_setup_hdd_format   dialog_setup_hdd_format
734   setup_hdd_format_flash > /dev/null   setup_hdd_format > /dev/null
735   install_mount_rootfs_flash   install_mount_rootfs
736   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | dialog_install_meter | dialog_install_system_image   (install_system_image > /tmp/install.log) 2> /tmp/install_errors.log | install_meter | dialog_install_system_image
737    
738   dialog_install_settings   dialog_install_settings
739   sleep 1   sleep 1
740   install_system_settings_flash   install_system_settings
741     dialog_install_initrd
742   install_initrd_chroot   install_initrd_chroot
743    
744   dialog_install_bootsector   dialog_install_bootsector
745   install_bootsector_chroot   install_bootsector_chroot
746    
747   install_umount_rootfs_flash   install_umount_rootfs
748   dialog_install_successful   dialog_install_successful
749  }  }
750    
751    # set some proper traps
752    trap "trap_exit" SIGINT SIGQUIT
753    
754  dialog_main  dialog_main
755    
756  exit 0  exit 0

Legend:
Removed from v.2323  
changed lines
  Added in v.2427